<!DOCTYPE html>
<html>

<head>
  <meta charset='utf-8'>
  <title>Pizza 365 project</title>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container">
    <p class="h3 text-center mt-5"> Chọn đồ uống </p>
    <div class="form-group col-12">
      <hr class="mt-5 mb-5" />
    </div>

    <div class="form-group">
      <label>Đồ uống:</label>
      <select id="select-drinking" class="form-control">
        <option>Chọn đồ uống</option>
      </select>
    </div>
    <button id="show-result" class="btn btn-primary w-25" onclick="onBtnDisplayClick()">Hiển thị</button>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    var dbData = [];
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      // Hàm xử lý khi load trang
      function onPageLoading(){
        "use strict";
        // Bước 1: Tạo đối tượng

        // Bước 2: Kiểm tra dữ liệu

        // Bước 3: Gọi API lấy dữ liệu từ server
          var vXmlHttp = new XMLHttpRequest();
          processApi(vXmlHttp);
        // Bước 4: Đổ dữ liệu vào select
          vXmlHttp.onreadystatechange =
          function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
              //console.log(vXmlHttp.responseText); //ghi response text ra console.log              
              fillDataToSelect(vXmlHttp.responseText);
            }
          };
          
      }
      // Hàm xử lý khi click nút hiển thị
      function onBtnDisplayClick(){
        "use strict";
        // Bước 0: Tạo đối tượng dữ liệu
          var vObject = {
            value:"",
            text:""
          }
        // Bước 1: Thu thập dữ liệu
          getDataFromSelect(vObject);
          console.log(vObject);
        // Bước 2: Kiểm tra dữ liệu - bỏ qua
        // Bước 3: Hiển thị dữ liệu
          displayData(vObject);      
        
      }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm hiển thị kết quả 
    function displayData(paramData){
      "use strict";
      console.log("Giá trị select được chọn là: " + paramData.value);
      console.log("Text select được chọn là: " + paramData.text);
    }
    // Hàm thu thập dữ liệu
    function getDataFromSelect(paramObject){
      "use strict";
      var vSelect = document.getElementById("select-drinking");
      paramObject.value = vSelect.value;
      paramObject.text = vSelect.options[vSelect.selectedIndex].text;
    }
    // Hàm xử lý API 
    // Input là đối tượng request
    function processApi(paramRequest){
      "use strict";
      paramRequest.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      paramRequest.send();
    }
    // Hàm đổ dữ liệu vào select
    function fillDataToSelect(paramData){
      "use strict";
      var vData = JSON.parse(paramData);
      console.log(vData);
      var vSelect = document.getElementById("select-drinking");
      for (var bI = 0; bI< vData.length; bI++){
          var bOpt = document.createElement('option');
          bOpt.value = vData[bI].maNuocUong;
          bOpt.innerHTML = vData[bI].tenNuocUong;
          vSelect.appendChild(bOpt);
      }
    }
    //mã nguồn để load data về
    /*function sampleCodeLoadData() {
      var xhttp = new XMLHttpRequest();
      vXmlHttp.onreadystatechange =
          function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
              console.log(xhttp.responseText); //ghi response text ra console.log
            }
          };
      xhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      xhttp.send();
    }*/

  </script>
</body>

</html>